/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.49 Revision 1.56
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.49 2009/11/09 19:30:40 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.56 2009/12/22 17:04:07 abcd Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Ben de Groot <yngwin@gentoo.org>,
8# Markos Chandras <hwoarang@gentoo.org>, 8# Markos Chandras <hwoarang@gentoo.org>,
12# @DESCRIPTION: 12# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 13# This eclass contains various functions that are used when building Qt4
14 14
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 15inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 16
17IUSE="${IUSE} debug pch" 17IUSE="debug pch"
18RDEPEND=" 18RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 19 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 20 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 21 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 22 !>x11-libs/qt-core-${PV}-r9999
43 !<x11-libs/qt-webkit-${PV} 43 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 44 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 45 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 46 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 47"
48case "${PV}" in 48
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}" 49MY_PV=${PV/_/-}
52 ;;
53 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}"
55 MY_PV="${PV}"
56 ;;
57esac
58 50
59if version_is_at_least 4.5.99999999 ${PV} ; then 51if version_is_at_least 4.5.99999999 ${PV} ; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}" 52 MY_P=qt-everywhere-opensource-src-${MY_PV}
61else 53else
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}" 54 MY_P=qt-x11-opensource-src-${MY_PV}
63fi 55fi
56
64S=${WORKDIR}/${MY_P} 57S=${WORKDIR}/${MY_P}
65 58
66HOMEPAGE="http://qt.nokia.com/" 59HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 60SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72 61
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )" 62LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81 63
82# @FUNCTION: qt4-build_pkg_setup 64# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 65# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 66# Sets up PATH and LD_LIBRARY_PATH
85qt4-build_pkg_setup() { 67qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 68 PATH="${S}/bin${PATH:+:}${PATH}"
69 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
70
71 # Make sure ebuilds use the required EAPI
87 if [[ $EAPI != 2 ]]; then 72 if [[ ${EAPI} != 2 ]]; then
88 # Make sure debug setting corresponds with qt-core (bug 258512) 73 eerror "The qt4-build eclass requires EAPI=2, but this ebuild does not"
89 if [[ $PN != "qt-core" ]]; then 74 eerror "have EAPI=2 set. The ebuild author or editor failed. This ebuild needs"
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 75 eerror "to be fixed. Using qt4-build eclass without EAPI=2 will fail."
91 ~x11-libs/qt-core-${PV} debug" 76 die "qt4-build eclass requires EAPI=2"
92 fi 77 fi
93 78
94 # Check USE requirements
95 qt4-build_check_use
96 fi
97
98 PATH="${S}/bin:${PATH}"
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
100
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 79 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 80 ewarn "Using a GCC version lower than 4.1 is not supported!"
103 echo 81 echo
104 ebeep 3 82 ebeep 3
105 fi 83 fi
84
85 if [[ ${P} == qt-core-4.6.0_rc1 ]]; then
86 ewarn
87 ewarn "Binary compatibility broke between 4.6.0_beta1 and 4.6.0_rc1."
88 ewarn "If you are upgrading from 4.6.0_beta1, you'll have to"
89 ewarn "re-emerge everything that depends on Qt."
90 ewarn "Use the following command:"
91 ewarn
92 ewarn " emerge -av1 \$(for i in \$(qlist -IC x11-libs/qt-);"
93 ewarn " do equery -q d \$i | grep -v 'x11-libs/qt-' |"
94 ewarn " sed \"s/^/=/\"; done)"
95 ewarn
96 ewarn "YOU'VE BEEN WARNED"
97 ewarn
98 ebeep 3
99 fi
100
106} 101}
107 102
108# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 103# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
109# @DESCRIPTION: 104# @DESCRIPTION:
110# Arguments for build_target_directories. Takes the directories, in which the 105# Arguments for build_target_directories. Takes the directories, in which the
118# @FUNCTION: qt4-build_src_unpack 113# @FUNCTION: qt4-build_src_unpack
119# @DESCRIPTION: 114# @DESCRIPTION:
120# Unpacks the sources 115# Unpacks the sources
121qt4-build_src_unpack() { 116qt4-build_src_unpack() {
122 setqtenv 117 setqtenv
123 local target targets licenses tar_pkg tar_args 118 local target targets=
124 if version_is_at_least 4.5 ${PV} ; then 119 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
125 licenses="LICENSE.GPL3 LICENSE.LGPL"
126 else
127 licenses="LICENSE.GPL2 LICENSE.GPL3"
128 fi
129 for target in configure ${licenses} projects.pro \
130 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 120 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
131 ${QT4_EXTRACT_DIRECTORIES}; do 121 ${QT4_EXTRACT_DIRECTORIES}; do
132 targets="${targets} ${MY_P}/${target}" 122 targets+=" ${MY_P}/${target}"
133 done 123 done
134 124
135 tar_pkg=${MY_P}.tar.bz2
136 tar_args="xjpf"
137 if version_is_at_least 4.5.3 ${PV} ; then
138 tar_pkg=${tar_pkg/bz2/gz}
139 tar_args="xzpf"
140 fi
141
142 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
143 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
144
145 case "${PV}" in
146 4.4.?)
147 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2 125 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
148 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2 126 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
149 ;;
150 esac
151
152 # Be backwards compatible for now
153 if [[ $EAPI != 2 ]]; then
154 qt4-build_src_prepare
155 fi
156} 127}
157 128
158# @ECLASS-VARIABLE: PATCHES 129# @ECLASS-VARIABLE: PATCHES
159# @DESCRIPTION: 130# @DESCRIPTION:
160# In case you have patches to apply, specify them in PATCHES variable. Make sure 131# In case you have patches to apply, specify them in PATCHES variable. Make sure
176 skip_qmake_build_patch 147 skip_qmake_build_patch
177 skip_project_generation_patch 148 skip_project_generation_patch
178 symlink_binaries_to_buildtree 149 symlink_binaries_to_buildtree
179 fi 150 fi
180 151
152 # Bug 282984 && Bug 295530
153 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
154 -i configure || die "sed qmake compilers failed"
155 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
156 -i config.tests/unix/compile.test || die "sed test compilers failed"
157
181 # Bug 178652 158 # Bug 178652
182 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 159 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
183 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 160 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
184 append-flags -fno-gcse 161 append-flags -fno-gcse
185 fi 162 fi
186 163
187 # Unsupported old gcc versions - hardened needs this :( 164 # Unsupported old gcc versions - hardened needs this :(
188 if [[ $(gcc-major-version) -lt "4" ]] ; then 165 if [[ $(gcc-major-version) -lt 4 ]] ; then
189 ewarn "Appending -fno-stack-protector to CXXFLAGS" 166 ewarn "Appending -fno-stack-protector to CXXFLAGS"
190 append-cxxflags -fno-stack-protector 167 append-cxxflags -fno-stack-protector
191 # Bug 253127 168 # Bug 253127
192 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 169 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
193 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 170 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
228 205
229# @FUNCTION: qt4-build_src_compile 206# @FUNCTION: qt4-build_src_compile
230# @DESCRIPTION: Actual compile phase 207# @DESCRIPTION: Actual compile phase
231qt4-build_src_compile() { 208qt4-build_src_compile() {
232 setqtenv 209 setqtenv
233 # Be backwards compatible for now
234 if [[ $EAPI != 2 ]]; then
235 qt4-build_src_configure
236 fi
237 210
238 build_directories "${QT4_TARGET_DIRECTORIES}" 211 build_directories ${QT4_TARGET_DIRECTORIES}
239} 212}
240 213
241# @FUNCTION: qt4-build_src_install 214# @FUNCTION: qt4-build_src_install
242# @DESCRIPTION: 215# @DESCRIPTION:
243# Perform the actual installation including some library fixes. 216# Perform the actual installation including some library fixes.
244qt4-build_src_install() { 217qt4-build_src_install() {
245 setqtenv 218 setqtenv
246 install_directories "${QT4_TARGET_DIRECTORIES}" 219 install_directories ${QT4_TARGET_DIRECTORIES}
247 install_qconfigs 220 install_qconfigs
248 fix_library_files 221 fix_library_files
249} 222}
250 223
251# @FUNCTION: setqtenv 224# @FUNCTION: setqtenv
274# @FUNCTION: standard_configure_options 247# @FUNCTION: standard_configure_options
275# @DESCRIPTION: 248# @DESCRIPTION:
276# Sets up some standard configure options, like libdir (if necessary), whether 249# Sets up some standard configure options, like libdir (if necessary), whether
277# debug info is wanted or not. 250# debug info is wanted or not.
278standard_configure_options() { 251standard_configure_options() {
279 local myconf="" 252 local myconf=
280 253
281 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 254 [[ $(get_libdir) != lib ]] && myconf+=" -L/usr/$(get_libdir)"
282 255
283 # Disable visibility explicitly if gcc version isn't 4 256 # Disable visibility explicitly if gcc version isn't 4
284 if [[ "$(gcc-major-version)" -lt "4" ]]; then 257 if [[ $(gcc-major-version) -lt 4 ]]; then
285 myconf="${myconf} -no-reduce-exports" 258 myconf+=" -no-reduce-exports"
286 fi 259 fi
287 260
288 # precompiled headers doesn't work on hardened, where the flag is masked. 261 # precompiled headers doesn't work on hardened, where the flag is masked.
262 myconf+=" $(qt_use pch)"
263
289 if use pch; then 264 if use debug; then
290 myconf="${myconf} -pch" 265 myconf+=" -debug"
291 else 266 else
292 myconf="${myconf} -no-pch" 267 myconf+=" -release"
293 fi 268 fi
294
295 if use debug; then
296 myconf="${myconf} -debug -no-separate-debug-info" 269 myconf+=" -no-separate-debug-info"
297 else
298 myconf="${myconf} -release -no-separate-debug-info"
299 fi
300 270
301 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 271 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
302 # $(tc-arch). Therefore we convert it to supported values. 272 # $(tc-arch). Therefore we convert it to supported values.
303 case "$(tc-arch)" in 273 case "$(tc-arch)" in
304 amd64) myconf="${myconf} -arch x86_64" ;; 274 amd64) myconf+=" -arch x86_64" ;;
305 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 275 ppc|ppc64) myconf+=" -arch powerpc" ;;
306 x86|x86-*) myconf="${myconf} -arch i386" ;; 276 x86|x86-*) myconf+=" -arch i386" ;;
307 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 277 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
308 hppa|sh) myconf="${myconf} -arch generic" ;; 278 hppa|sh) myconf+=" -arch generic" ;;
309 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 279 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
310 esac 280 esac
311 281
312 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 282 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
313 local exceptions= 283 local exceptions=
320 *) 290 *)
321 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 291 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
322 ;; 292 ;;
323 esac 293 esac
324 294
325 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath 295 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
326 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR} 296 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
327 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} 297 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
328 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR} 298 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
329 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR} 299 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
330 -demosdir ${QTDEMOSDIR} -silent -fast 300 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
331 ${exceptions} 301 ${exceptions}
332 -reduce-relocations -nomake examples -nomake demos" 302 -reduce-relocations -nomake examples -nomake demos"
333 303
334 # Make eclass >= 4.5.x ready
335 case "${MY_PV}" in
336 4.5.* | 4.6.* )
337 myconf="${myconf} -opensource"
338 ;;
339 esac
340
341 echo "${myconf}" 304 echo "${myconf}"
342} 305}
343 306
344# @FUNCTION: build_directories 307# @FUNCTION: build_directories
345# @USAGE: < directories > 308# @USAGE: < directories >
346# @DESCRIPTION: 309# @DESCRIPTION:
347# Compiles the code in $QT4_TARGET_DIRECTORIES 310# Compiles the code in $QT4_TARGET_DIRECTORIES
348build_directories() { 311build_directories() {
349 local dirs="$@"
350 for x in ${dirs}; do 312 for x in "$@"; do
351 cd "${S}"/${x} 313 cd "${S}"/${x}
352 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 314 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die
353 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 315 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
354 emake CC="@echo compiling \$< && $(tc-getCC)" \ 316 emake CC="@echo compiling \$< && $(tc-getCC)" \
355 CXX="@echo compiling \$< && $(tc-getCXX)" \ 317 CXX="@echo compiling \$< && $(tc-getCXX)" \
360# @FUNCTION: install_directories 322# @FUNCTION: install_directories
361# @USAGE: < directories > 323# @USAGE: < directories >
362# @DESCRIPTION: 324# @DESCRIPTION:
363# run emake install in the given directories, which are separated by spaces 325# run emake install in the given directories, which are separated by spaces
364install_directories() { 326install_directories() {
365 local dirs="$@"
366 for x in ${dirs}; do 327 for x in "$@"; do
367 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 328 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}"
368 emake INSTALL_ROOT="${D}" install || die "emake install failed" 329 emake INSTALL_ROOT="${D}" install || die "emake install failed"
369 popd >/dev/null || die "Can't popd from ${S}/${x}" 330 popd >/dev/null || die "Can't popd from ${S}/${x}"
370 done 331 done
371} 332}
372 333
373# @ECLASS-VARIABLE: QCONFIG_ADD 334# @ECLASS-VARIABLE: QCONFIG_ADD
374# @DESCRIPTION: 335# @DESCRIPTION:
375# List options that need to be added to QT_CONFIG in qconfig.pri 336# List options that need to be added to QT_CONFIG in qconfig.pri
376QCONFIG_ADD="${QCONFIG_ADD:-}" 337: ${QCONFIG_ADD:=}
377 338
378# @ECLASS-VARIABLE: QCONFIG_REMOVE 339# @ECLASS-VARIABLE: QCONFIG_REMOVE
379# @DESCRIPTION: 340# @DESCRIPTION:
380# List options that need to be removed from QT_CONFIG in qconfig.pri 341# List options that need to be removed from QT_CONFIG in qconfig.pri
381QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 342: ${QCONFIG_REMOVE:=}
382 343
383# @ECLASS-VARIABLE: QCONFIG_DEFINE 344# @ECLASS-VARIABLE: QCONFIG_DEFINE
384# @DESCRIPTION: 345# @DESCRIPTION:
385# List variables that should be defined at the top of QtCore/qconfig.h 346# List variables that should be defined at the top of QtCore/qconfig.h
386QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 347: ${QCONFIG_DEFINE:=}
387 348
388# @FUNCTION: install_qconfigs 349# @FUNCTION: install_qconfigs
389# @DESCRIPTION: Install gentoo-specific mkspecs configurations 350# @DESCRIPTION: Install gentoo-specific mkspecs configurations
390install_qconfigs() { 351install_qconfigs() {
391 local x 352 local x
411generate_qconfigs() { 372generate_qconfigs() {
412 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 373 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
413 local x qconfig_add qconfig_remove qconfig_new 374 local x qconfig_add qconfig_remove qconfig_new
414 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 375 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
415 [[ -f ${x} ]] || continue 376 [[ -f ${x} ]] || continue
416 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 377 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
417 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 378 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
418 done 379 done
419 380
420 # these error checks do not use die because dying in pkg_post{inst,rm} 381 # these error checks do not use die because dying in pkg_post{inst,rm}
421 # just makes things worse. 382 # just makes things worse.
422 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 383 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
429 390
430 # generate list of QT_CONFIG entries from the existing list 391 # generate list of QT_CONFIG entries from the existing list
431 # including qconfig_add and excluding qconfig_remove 392 # including qconfig_add and excluding qconfig_remove
432 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 393 for x in $(sed -n 's/^QT_CONFIG +=//p' \
433 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 394 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
434 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 395 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
435 done 396 done
436 397
437 # replace the existing QT_CONFIG list with qconfig_new 398 # replace the existing QT_CONFIG list with qconfig_new
438 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 399 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
439 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 400 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
473# @FUNCTION: qt4-build_pkg_postinst 434# @FUNCTION: qt4-build_pkg_postinst
474# @DESCRIPTION: Generate configuration, plus throws a message about possible 435# @DESCRIPTION: Generate configuration, plus throws a message about possible
475# breakages and proposed solutions. 436# breakages and proposed solutions.
476qt4-build_pkg_postinst() { 437qt4-build_pkg_postinst() {
477 generate_qconfigs 438 generate_qconfigs
439
440 if [[ "${PN}" == "qt-core" ]]; then
478 echo 441 echo
479 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt" 442 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
480 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you" 443 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
481 ewarn "should recompile the packages providing these plugins. Also, make sure you" 444 ewarn "should recompile the packages providing these plugins. Also, make sure you"
482 ewarn "compile the Qt packages, and the packages that depend on it, with the same" 445 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
483 ewarn "GCC version and the same USE flag settings (especially the debug flag)." 446 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
484 ewarn 447 ewarn
485 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any" 448 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
486 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report," 449 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
487 ewarn "make sure all your Qt4 packages are up-to-date and built with the same" 450 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
488 ewarn "configuration." 451 ewarn "configuration."
489 ewarn 452 ewarn
490 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html" 453 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
491 echo 454 echo
455 fi
492} 456}
493 457
494# @FUNCTION: skip_qmake_build_patch 458# @FUNCTION: skip_qmake_build_patch
495# @DESCRIPTION: 459# @DESCRIPTION:
496# Don't need to build qmake, as it's already installed from qt-core 460# Don't need to build qmake, as it's already installed from qt-core
532 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 496 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix:
533 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 497 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
534 if [[ -e ${libfile} ]]; then 498 if [[ -e ${libfile} ]]; then
535 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 499 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed"
536 500
537 # Move .pc files into the pkgconfig directory 501 # Move .pc files into the pkgconfig directory
538 dodir ${QTPCDIR} 502 dodir ${QTPCDIR}
539 mv ${libfile} "${D}"/${QTPCDIR}/ \ 503 mv ${libfile} "${D}"/${QTPCDIR}/ \
540 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed." 504 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
541 fi 505 fi
542 done 506 done
551# This will echo "${enableval}-${feature}" if <flag> is enabled, or 515# This will echo "${enableval}-${feature}" if <flag> is enabled, or
552# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 516# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag>
553# will be used for that. If [enableval] is not specified, it omits the 517# will be used for that. If [enableval] is not specified, it omits the
554# assignment-part 518# assignment-part
555qt_use() { 519qt_use() {
556 local flag="${1}" 520 local flag=$1
557 local feature="${1}" 521 local feature=$1
558 local enableval= 522 local enableval=
559 523
560 [[ -n ${2} ]] && feature=${2} 524 [[ -n $2 ]] && feature=$2
561 [[ -n ${3} ]] && enableval="-${3}" 525 [[ -n $3 ]] && enableval=-$3
562 526
563 if use ${flag}; then 527 if use ${flag}; then
564 echo "${enableval}-${feature}" 528 echo "${enableval}-${feature}"
565 else 529 else
566 echo "-no-${feature}" 530 echo "-no-${feature}"
567 fi 531 fi
568} 532}
569 533
570# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
571# @DESCRIPTION:
572# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
573# (eutils.eclass), line per line.
574#
575# Example:
576# @CODE
577# pkg_setup() {
578# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
579# ~x11-libs/qt-gui-${PV} qt3support"
580# qt4-build_check_use
581# }
582# @CODE
583
584# Run built_with_use on each flag and print appropriate error messages if any
585# flags are missing
586
587_qt_built_with_use() {
588 local missing opt pkg flag flags
589
590 if [[ ${1} = "--missing" ]]; then
591 missing="${1} ${2}" && shift 2
592 fi
593 if [[ ${1:0:1} = "-" ]]; then
594 opt=${1} && shift
595 fi
596
597 pkg=${1} && shift
598
599 for flag in "${@}"; do
600 flags="${flags} ${flag}"
601 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
602 flags="${flags}*"
603 else
604 [[ ${opt} = "-o" ]] && return 0
605 fi
606 done
607 if [[ "${flags# }" = "${@}" ]]; then
608 return 0
609 fi
610 if [[ ${opt} = "-o" ]]; then
611 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
612 else
613 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
614 fi
615 return 1
616}
617
618# @FUNCTION: qt4-build_check_use
619# @DESCRIPTION:
620# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
621# USE flags listed.
622#
623# If any of the required USE flags are missing, an eerror will be printed for
624# each package with missing USE flags.
625qt4-build_check_use() {
626 local line missing
627 while read line; do
628 [[ -z ${line} ]] && continue
629 if ! _qt_built_with_use ${line}; then
630 missing=true
631 fi
632 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
633 if [[ -n ${missing} ]]; then
634 echo
635 eerror "Flags marked with an * are missing."
636 die "Missing USE flags found"
637 fi
638}
639
640# @FUNCTION: qt_mkspecs_dir 534# @FUNCTION: qt_mkspecs_dir
641# @RETURN: the specs-directory w/o path 535# @RETURN: the specs-directory w/o path
642# @DESCRIPTION: 536# @DESCRIPTION:
643# Allows us to define which mkspecs dir we want to use. 537# Allows us to define which mkspecs dir we want to use.
644qt_mkspecs_dir() { 538qt_mkspecs_dir() {
645 # Allows us to define which mkspecs dir we want to use. 539 # Allows us to define which mkspecs dir we want to use.
646 local spec 540 local spec
647 541
648 case ${CHOST} in 542 case ${CHOST} in
649 *-freebsd*|*-dragonfly*) 543 *-freebsd*|*-dragonfly*)
650 spec="freebsd" ;; 544 spec=freebsd ;;
651 *-openbsd*) 545 *-openbsd*)
652 spec="openbsd" ;; 546 spec=openbsd ;;
653 *-netbsd*) 547 *-netbsd*)
654 spec="netbsd" ;; 548 spec=netbsd ;;
655 *-darwin*) 549 *-darwin*)
656 spec="darwin" ;; 550 spec=darwin ;;
657 *-linux-*|*-linux) 551 *-linux-*|*-linux)
658 spec="linux" ;; 552 spec=linux ;;
659 *) 553 *)
660 die "Unknown CHOST, no platform choosen." 554 die "Unknown CHOST, no platform choosen."
661 esac 555 esac
662 556
663 CXX=$(tc-getCXX) 557 CXX=$(tc-getCXX)
664 if [[ ${CXX/g++/} != ${CXX} ]]; then 558 if [[ ${CXX} == *g++* ]]; then
665 spec="${spec}-g++" 559 spec+=-g++
666 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 560 elif [[ ${CXX} == *icpc* ]]; then
667 spec="${spec}-icc" 561 spec+=-icc
668 else 562 else
669 die "Unknown compiler ${CXX}." 563 die "Unknown compiler ${CXX}."
670 fi 564 fi
671 if [[ -n "${LIBDIR/lib}" ]]; then 565 if [[ -n ${LIBDIR/lib} ]]; then
672 spec="${spec}-${LIBDIR/lib}" 566 spec+=-${LIBDIR/lib}
673 fi 567 fi
674 568
675 echo "${spec}" 569 echo "${spec}"
676} 570}
677 571
678case ${EAPI:-0} in
679 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;;
680 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 572EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst
681esac

Legend:
Removed from v.1.49  
changed lines
  Added in v.1.56

  ViewVC Help
Powered by ViewVC 1.1.20